package co.fast.flutter.sdk

import android.util.Log
import co.fast.android.sdk.checkout.FastCheckoutEvent
import io.flutter.plugin.common.EventChannel
import java.io.Closeable

class FastCheckoutEventChannelStreamHandler : EventChannel.StreamHandler, Closeable {
    private var eventSink: EventChannel.EventSink? = null

    override fun onListen(arguments: Any?, events: EventChannel.EventSink?) {
        Log.d(TAG, "onListen(). events=$events")
        eventSink = events
    }

    override fun onCancel(arguments: Any?) {
        Log.d(TAG, "onCancel()")
        eventSink = null
    }

    fun emit(event: FastCheckoutEvent) {
        val sink = eventSink
        checkNotNull(sink) { "Sink is null. Cannot send event" }
        sink.success(event.toFlutterFastCheckoutEvent())
    }

    companion object {
        private val TAG = FastCheckoutEventChannelStreamHandler::class.java.simpleName.take(23)
    }

    override fun close() {
        eventSink?.endOfStream()
        eventSink = null
    }
}