// Autogenerated from Pigeon (v2.0.3), do not edit directly.
// See also: https://pub.dev/packages/pigeon
#import <Foundation/Foundation.h>
@protocol FlutterBinaryMessenger;
@protocol FlutterMessageCodec;
@class FlutterError;
@class FlutterStandardTypedData;

NS_ASSUME_NONNULL_BEGIN

typedef NS_ENUM(NSUInteger, FlutterFastEventType) {
  FlutterFastEventTypeOrderCreated = 0,
  FlutterFastEventTypeOrderUpdated = 1,
  FlutterFastEventTypeOrderCompleted = 2,
  FlutterFastEventTypeOrderCanceled = 3,
  FlutterFastEventTypeOrderFailed = 4,
  FlutterFastEventTypeClosed = 5,
};

typedef NS_ENUM(NSUInteger, FlutterFastEventInfoKey) {
  FlutterFastEventInfoKeyError = 0,
  FlutterFastEventInfoKeyPurchaseInfo = 1,
};

@class FlutterProduct;
@class FlutterProductOption;
@class FlutterFastEvent;
@class FlutterPurchaseInfo;
@class FlutterPurchaseItem;

@interface FlutterProduct : NSObject
+ (instancetype)makeWithId:(nullable NSString *)id
    variantId:(nullable NSString *)variantId
    productOptions:(nullable NSArray<FlutterProductOption *> *)productOptions
    quantity:(nullable NSNumber *)quantity;
@property(nonatomic, copy, nullable) NSString * id;
@property(nonatomic, copy, nullable) NSString * variantId;
@property(nonatomic, strong, nullable) NSArray<FlutterProductOption *> * productOptions;
@property(nonatomic, strong, nullable) NSNumber * quantity;
@end

@interface FlutterProductOption : NSObject
+ (instancetype)makeWithId:(nullable NSString *)id
    value:(nullable NSString *)value;
@property(nonatomic, copy, nullable) NSString * id;
@property(nonatomic, copy, nullable) NSString * value;
@end

@interface FlutterFastEvent : NSObject
+ (instancetype)makeWithEventType:(FlutterFastEventType)eventType
    purchaseInfo:(nullable FlutterPurchaseInfo *)purchaseInfo
    error:(nullable NSString *)error;
@property(nonatomic, assign) FlutterFastEventType eventType;
@property(nonatomic, strong, nullable) FlutterPurchaseInfo * purchaseInfo;
@property(nonatomic, copy, nullable) NSString * error;
@end

@interface FlutterPurchaseInfo : NSObject
+ (instancetype)makeWithPlatformId:(nullable NSString *)platformId
    revenue:(nullable NSString *)revenue
    tax:(nullable NSString *)tax
    shipping:(nullable NSString *)shipping
    currencyCode:(nullable NSString *)currencyCode
    coupon:(nullable NSString *)coupon
    checkoutTime:(nullable NSNumber *)checkoutTime
    items:(nullable NSArray<FlutterPurchaseItem *> *)items;
@property(nonatomic, copy, nullable) NSString * platformId;
@property(nonatomic, copy, nullable) NSString * revenue;
@property(nonatomic, copy, nullable) NSString * tax;
@property(nonatomic, copy, nullable) NSString * shipping;
@property(nonatomic, copy, nullable) NSString * currencyCode;
@property(nonatomic, copy, nullable) NSString * coupon;
@property(nonatomic, strong, nullable) NSNumber * checkoutTime;
@property(nonatomic, strong, nullable) NSArray<FlutterPurchaseItem *> * items;
@end

@interface FlutterPurchaseItem : NSObject
+ (instancetype)makeWithPlatformId:(nullable NSString *)platformId
    platformVariantId:(nullable NSString *)platformVariantId
    name:(nullable NSString *)name
    price:(nullable NSString *)price
    quantity:(nullable NSNumber *)quantity
    coupon:(nullable NSString *)coupon;
@property(nonatomic, copy, nullable) NSString * platformId;
@property(nonatomic, copy, nullable) NSString * platformVariantId;
@property(nonatomic, copy, nullable) NSString * name;
@property(nonatomic, copy, nullable) NSString * price;
@property(nonatomic, strong, nullable) NSNumber * quantity;
@property(nonatomic, copy, nullable) NSString * coupon;
@end

/// The codec used by FlutterFastFlutterApi.
NSObject<FlutterMessageCodec> *FlutterFastFlutterApiGetCodec(void);

@protocol FlutterFastFlutterApi
- (void)configureAppId:(NSString *)appId completion:(void(^)(FlutterError *_Nullable))completion;
- (void)resetWithCompletion:(void(^)(FlutterError *_Nullable))completion;
- (void)checkoutWithProductsProducts:(NSArray<FlutterProduct *> *)products currencyCode:(nullable NSString *)currencyCode couponCode:(nullable NSString *)couponCode completion:(void(^)(FlutterError *_Nullable))completion;
- (void)checkoutWithCartIdCartId:(NSString *)cartId currencyCode:(nullable NSString *)currencyCode completion:(void(^)(FlutterError *_Nullable))completion;
- (void)_unusedEvent:(FlutterFastEvent *)event completion:(void(^)(FlutterError *_Nullable))completion;
@end

extern void FlutterFastFlutterApiSetup(id<FlutterBinaryMessenger> binaryMessenger, NSObject<FlutterFastFlutterApi> *_Nullable api);

NS_ASSUME_NONNULL_END
