// Autogenerated from Pigeon (v2.0.3), do not edit directly.
// See also: https://pub.dev/packages/pigeon
// ignore_for_file: public_member_api_docs, non_constant_identifier_names, avoid_as, unused_import, unnecessary_parenthesis, prefer_null_aware_operators, omit_local_variable_types, unused_shown_name
// @dart = 2.12
import 'dart:async';
import 'dart:typed_data' show Uint8List, Int32List, Int64List, Float64List;

import 'package:flutter/foundation.dart' show WriteBuffer, ReadBuffer;
import 'package:flutter/services.dart';

enum FastEventType {
  orderCreated,
  orderUpdated,
  orderCompleted,
  orderCanceled,
  orderFailed,
  closed,
}

enum FastEventInfoKey {
  error,
  purchaseInfo,
}

class Product {
  Product({
    this.id,
    this.variantId,
    this.productOptions,
    this.quantity,
  });

  String? id;
  String? variantId;
  List<ProductOption?>? productOptions;
  int? quantity;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['id'] = id;
    pigeonMap['variantId'] = variantId;
    pigeonMap['productOptions'] = productOptions;
    pigeonMap['quantity'] = quantity;
    return pigeonMap;
  }

  static Product decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return Product(
      id: pigeonMap['id'] as String?,
      variantId: pigeonMap['variantId'] as String?,
      productOptions: (pigeonMap['productOptions'] as List<Object?>?)?.cast<ProductOption?>(),
      quantity: pigeonMap['quantity'] as int?,
    );
  }
}

class ProductOption {
  ProductOption({
    this.id,
    this.value,
  });

  String? id;
  String? value;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['id'] = id;
    pigeonMap['value'] = value;
    return pigeonMap;
  }

  static ProductOption decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return ProductOption(
      id: pigeonMap['id'] as String?,
      value: pigeonMap['value'] as String?,
    );
  }
}

class FastEvent {
  FastEvent({
    this.eventType,
    this.purchaseInfo,
    this.error,
  });

  FastEventType? eventType;
  PurchaseInfo? purchaseInfo;
  String? error;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['eventType'] = eventType == null ? null : eventType!.index;
    pigeonMap['purchaseInfo'] = purchaseInfo == null ? null : purchaseInfo!.encode();
    pigeonMap['error'] = error;
    return pigeonMap;
  }

  static FastEvent decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return FastEvent(
      eventType: pigeonMap['eventType'] != null
          ? FastEventType.values[pigeonMap['eventType']! as int]
          : null,
      purchaseInfo: pigeonMap['purchaseInfo'] != null
          ? PurchaseInfo.decode(pigeonMap['purchaseInfo']!)
          : null,
      error: pigeonMap['error'] as String?,
    );
  }
}

class PurchaseInfo {
  PurchaseInfo({
    this.platformId,
    this.revenue,
    this.tax,
    this.shipping,
    this.currencyCode,
    this.coupon,
    this.checkoutTime,
    this.items,
  });

  String? platformId;
  String? revenue;
  String? tax;
  String? shipping;
  String? currencyCode;
  String? coupon;
  int? checkoutTime;
  List<PurchaseItem?>? items;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['platformId'] = platformId;
    pigeonMap['revenue'] = revenue;
    pigeonMap['tax'] = tax;
    pigeonMap['shipping'] = shipping;
    pigeonMap['currencyCode'] = currencyCode;
    pigeonMap['coupon'] = coupon;
    pigeonMap['checkoutTime'] = checkoutTime;
    pigeonMap['items'] = items;
    return pigeonMap;
  }

  static PurchaseInfo decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return PurchaseInfo(
      platformId: pigeonMap['platformId'] as String?,
      revenue: pigeonMap['revenue'] as String?,
      tax: pigeonMap['tax'] as String?,
      shipping: pigeonMap['shipping'] as String?,
      currencyCode: pigeonMap['currencyCode'] as String?,
      coupon: pigeonMap['coupon'] as String?,
      checkoutTime: pigeonMap['checkoutTime'] as int?,
      items: (pigeonMap['items'] as List<Object?>?)?.cast<PurchaseItem?>(),
    );
  }
}

class PurchaseItem {
  PurchaseItem({
    this.platformId,
    this.platformVariantId,
    this.name,
    this.price,
    this.quantity,
    this.coupon,
  });

  String? platformId;
  String? platformVariantId;
  String? name;
  String? price;
  int? quantity;
  String? coupon;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['platformId'] = platformId;
    pigeonMap['platformVariantId'] = platformVariantId;
    pigeonMap['name'] = name;
    pigeonMap['price'] = price;
    pigeonMap['quantity'] = quantity;
    pigeonMap['coupon'] = coupon;
    return pigeonMap;
  }

  static PurchaseItem decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return PurchaseItem(
      platformId: pigeonMap['platformId'] as String?,
      platformVariantId: pigeonMap['platformVariantId'] as String?,
      name: pigeonMap['name'] as String?,
      price: pigeonMap['price'] as String?,
      quantity: pigeonMap['quantity'] as int?,
      coupon: pigeonMap['coupon'] as String?,
    );
  }
}

class _FastFlutterApiCodec extends StandardMessageCodec {
  const _FastFlutterApiCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is FastEvent) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else 
    if (value is Product) {
      buffer.putUint8(129);
      writeValue(buffer, value.encode());
    } else 
    if (value is ProductOption) {
      buffer.putUint8(130);
      writeValue(buffer, value.encode());
    } else 
    if (value is PurchaseInfo) {
      buffer.putUint8(131);
      writeValue(buffer, value.encode());
    } else 
    if (value is PurchaseItem) {
      buffer.putUint8(132);
      writeValue(buffer, value.encode());
    } else 
{
      super.writeValue(buffer, value);
    }
  }
  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:       
        return FastEvent.decode(readValue(buffer)!);
      
      case 129:       
        return Product.decode(readValue(buffer)!);
      
      case 130:       
        return ProductOption.decode(readValue(buffer)!);
      
      case 131:       
        return PurchaseInfo.decode(readValue(buffer)!);
      
      case 132:       
        return PurchaseItem.decode(readValue(buffer)!);
      
      default:      
        return super.readValueOfType(type, buffer);
      
    }
  }
}

class FastFlutterApi {
  /// Constructor for [FastFlutterApi].  The [binaryMessenger] named argument is
  /// available for dependency injection.  If it is left null, the default
  /// BinaryMessenger will be used which routes to the host platform.
  FastFlutterApi({BinaryMessenger? binaryMessenger}) : _binaryMessenger = binaryMessenger;

  final BinaryMessenger? _binaryMessenger;

  static const MessageCodec<Object?> codec = _FastFlutterApiCodec();

  Future<void> configure(String arg_appId) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.FastFlutterApi.configure', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object?>[arg_appId]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else {
      return;
    }
  }

  Future<void> reset() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.FastFlutterApi.reset', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(null) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else {
      return;
    }
  }

  Future<void> checkoutWithProducts(List<Product?> arg_products, String? arg_currencyCode, String? arg_couponCode) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.FastFlutterApi.checkoutWithProducts', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object?>[arg_products, arg_currencyCode, arg_couponCode]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else {
      return;
    }
  }

  Future<void> checkoutWithCartId(String arg_cartId, String? arg_currencyCode) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.FastFlutterApi.checkoutWithCartId', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object?>[arg_cartId, arg_currencyCode]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else {
      return;
    }
  }

  Future<void> _unused(FastEvent arg_event) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.FastFlutterApi._unused', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object?>[arg_event]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else {
      return;
    }
  }
}
